# Subscribe

## What is this endpoint for? <a href="#what-is-this-endpoint-for" id="what-is-this-endpoint-for"></a>

Get a live feed / 72-hour replay for any Reference Rate from the following asset classes:

* Equity *<mark style="color:$info;">(unless "instrument type" is "futures")</mark>*
* Fixed income
* Foreign exchange
* Commodities
* Real estate
* Digital assets

For crypto rates, please see the crypto section of the documentation.

## Endpoint&#x20;

{% tabs %}
{% tab title="gRPC Stream" %}

```url
gateway.equ.kaiko.io:443 kaiko.equities.EquitiesService/StreamIndex
```

{% endtab %}

{% tab title="gRPC Replay" %}

<pre><code><strong>gateway.equ.kaiko.io:443 kaiko.equities.EquitiesService/ReplayIndex
</strong></code></pre>

{% endtab %}
{% endtabs %}

## Request parameters

{% hint style="info" %}
**Requesting multiple tickers at the same time**\
\
To configure multiple tickers in the same call, provide the  `index_codes` as a comma-separated list, e.g. `["KK_RFR_AAPLUSD", "KK_RFR_TSLAUSD"]` .
{% endhint %}

### Subscribe

<table><thead><tr><th width="184">Parameter</th><th width="377.296875">Description</th><th>Examples</th></tr></thead><tbody><tr><td><code>index_codes</code></td><td>The list of Kaiko Reference Rate ticker. You can find a full list of our tickers <a href="https://www.kaiko.com/indices/reference-rates#table">here</a>.</td><td><code>["KK_RFR_AAPLUSD", "KK_RFR_TSLAUSD"]</code></td></tr></tbody></table>

### Replay

<table><thead><tr><th width="184">Parameter</th><th width="400">Description</th><th>Examples</th></tr></thead><tbody><tr><td><code>index_codes</code></td><td>The list of Kaiko Reference Rate ticker. You can find a full list of our tickers <a href="https://www.kaiko.com/indices/reference-rates#table">here</a>.</td><td><code>KK_RFR_AAPLUSD</code></td></tr><tr><td><code>start_time</code></td><td>Start date of <code>exDate</code> in ISO 8601 (exclusive).</td><td><code>2026-04-22T05:04:32.000Z</code></td></tr><tr><td><code>end_time</code></td><td>Start date of <code>exDate</code> in ISO 8601 (inclusive).</td><td><code>2026-04-22T05:04:33.000Z</code></td></tr></tbody></table>

## Response fields

<table><thead><tr><th width="210">Field</th><th width="537">Description</th></tr></thead><tbody><tr><td><code>index_codes</code></td><td>The list of tickers identifying the rate.</td></tr><tr><td><code>commodity</code></td><td>The type of publication. Either real-time or fixings</td></tr><tr><td><code>interval</code></td><td>The time period in which transaction data are considered for the calculation of the rate.</td></tr><tr><td>   <mark style="color:$tint;"><code>.startTime</code></mark></td><td>The start time of the data interval</td></tr><tr><td>   <mark style="color:$tint;"><code>.endTime</code></mark></td><td>The end time of the data interval</td></tr><tr><td><code>quote</code></td><td>The quote asset used for the rate denomination.</td></tr><tr><td><code>bases</code></td><td>The list of base assets included in the rate and their weight. For reference rates, this will always be a single asset. </td></tr><tr><td><code>exchanges</code></td><td>The exchanges involved in the computation. </td></tr><tr><td><code>percentages</code></td><td>The different distribution levels included in the price computation.</td></tr><tr><td><code>price</code></td><td>The value of the rate in the quote denomination.</td></tr><tr><td><code>pairs</code></td><td>The list of pairs combined with additional details included in the computation.</td></tr><tr><td><code>sessionDetector</code></td><td><p>The status of market session. </p><ul><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_EARLY_HOURS</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_REGULAR_HOURS</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_LATE_HOURS</code></mark></li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_OVERNIGHT</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_CLOSED_HOURS</code></mark></li></ul><p>Please refer to <a href="/pages/5oz054VQbdJFyWJzti4A">Market calendar and trading endpoint</a> for daily session schedule.</p></td></tr><tr><td><code>tsEvent</code></td><td>The exact time of price publication.</td></tr></tbody></table>

## Request examples

{% tabs %}
{% tab title="cURL Stream" %}
**cURL requests are intended for testing purposes only.**

{% code overflow="wrap" %}

```url
grpcurl \
  -H "Authorization: Bearer $KAIKO_API_KEY" \
  -d '{
    "index_codes": ["KK_RFR_TSLAUSD"]
  }' \
  gateway.equ.kaiko.io:443 \
  kaiko.equities.EquitiesService/StreamIndex
```

{% endcode %}
{% endtab %}

{% tab title="cURL Replay" %}
**cURL requests are intended for testing purposes only.**

{% code overflow="wrap" %}

```url
grpcurl \
  -H "Authorization: Bearer $KAIKO_API_KEY" \
  -d '{
    "index_codes": ["KK_RFR_TSLAUSD"],
    "start_time":  "2026-04-27T20:04:32.000Z",
    "end_time":    "2026-04-27T20:04:33.000Z"
  }' \
  gateway.equ.kaiko.io:443 \
  kaiko.equities.EquitiesService/ReplayIndex
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Response Example

```json
{
  "index": {
    "indexCode": "KK_RFR_TSLAUSD",
    "commodity": "INDEX_COMMODITY_REAL_TIME",
    "interval": {
      "startTime": "2026-04-27T20:04:17Z",
      "endTime": "2026-04-27T20:04:32Z"
    },
    "quote": "usd",
    "bases": [
      {
        "asset": "tsla",
        "weight": 1
      }
    ],
    "exchanges": [
      "nutp",
      "boat",
      "xcta"
    ],
    "percentages": [
      {
        "percentage": 1,
        "price": 378.03249999999997,
        "pairs": [
          {
            "pair": "tsla-usd",
            "weight": 1,
            "instruments": [
              {
                "partition": "2",
                "price": 378.025,
                "volume": 40,
                "count": "1",
                "underlyingTrade": {
                  "volume": 40,
                  "exchange": "nutp",
                  "id": "019dd08b-0635-7077-a949-0c4aa816bedd",
                  "datetime": "2026-04-27T20:04:25.247777Z"
                }
              },
              {
                "partition": "3",
                "price": 378.035,
                "volume": 240,
                "count": "2",
                "underlyingTrade": {
                  "volume": 200,
                  "exchange": "nutp",
                  "id": "019dd08b-0d81-7cd5-914c-5a4c62cdbcb3",
                  "datetime": "2026-04-27T20:04:27.122012Z"
                }
              },
              {
                "partition": "4",
                "price": 378.035,
                "volume": 200,
                "count": "1",
                "underlyingTrade": {
                  "volume": 200,
                  "exchange": "nutp",
                  "id": "019dd08b-1833-7ef6-931e-2ef59a4bcb81",
                  "datetime": "2026-04-27T20:04:29.866528Z"
                }
              }
            ]
          }
        ]
      }
    ],
    "tsEvent": "2026-04-27T20:04:32.346558794Z",
    "sequenceId": "d7ns2k20qd5c72pg0220",
    "lastIngestTime": "2026-04-27T20:04:30.678413576Z"
  },
  "sessionDetector": "INDEX_SESSION_DETECTOR_LATE_HOURS"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kaiko.com/kaiko-indices/reference-rates-capital-market/subscribe.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
